
Core - Bug # 55152

Epic # 47018 (Resolved): Implement Composer support and clean package manager API

Status: Closed Priority: Should have
Author: Christian Weiske Category: Extension Manager
Created: 2014-01-20 Assigned To: Thomas Maroschik
Updated: 2014-02-14 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity:
Is Regression: No
Sprint Focus:
Subject: Class 'TYPO3\Flow\Package\Exception\InvalidPackageStateException' not found
Description

When activating an extension with a dependency on a not activated but downloaded extension, I get the following exception in
6.2beta4:

Fatal error: Class 'TYPO3\Flow\Package\Exception\InvalidPackageStateException' not found in
/path/typo3_src/typo3/sysext/core/Resources/PHP/TYPO3.Flow/Classes/TYPO3/Flow/Package/PackageManager.php on line
382
Call Stack
#    Time    Memory    Function    Location
1    0.0001    681352    {main}( )    ../mod.php:0
2    0.1684    12874832    TYPO3\CMS\Extbase\Core\ModuleRunner->callModule( )    ../mod.php:47
3    0.1697    12901240    TYPO3\CMS\Extbase\Core\Bootstrap->run( )    ../ModuleRunner.php:81
4    0.4199    17277288    TYPO3\CMS\Extbase\Core\Bootstrap->handleRequest( )    ../Bootstrap.php:197
5    0.4349    17489496    TYPO3\CMS\Extbase\Mvc\Web\BackendRequestHandler->handleRequest( )    ../Bootstrap.php:208
6    0.4403    17681584    TYPO3\CMS\Extbase\Mvc\Dispatcher->dispatch( )    ../BackendRequestHandler.php:47
7    0.4911    18983072    TYPO3\CMS\Extbase\Mvc\Controller\ActionController->processRequest( )    ../Dispatcher.php:83
8    0.5764    20229784    TYPO3\CMS\Extbase\Mvc\Controller\ActionController->callActionMethod( )   
../ActionController.php:171
9    0.5767    20235688    call_user_func_array ( )    ../ActionController.php:300
10    0.5767    20236376   
TYPO3\CMS\Extensionmanager\Controller\ActionController->toggleExtensionInstallationStateAction( )   
../ActionController.php:300
11    0.5942    20535376   
TYPO3\CMS\Extensionmanager\Service\ExtensionManagementService->resolveDependenciesAndInstall( )   
../ActionController.php:78
12    0.6017    20659848    TYPO3\CMS\Extensionmanager\Service\ExtensionManagementService->installDependencies( )   
../ExtensionManagementService.php:138
13    1.3395    22031576    TYPO3\CMS\Extensionmanager\Utility\InstallUtility->install( )   
../ExtensionManagementService.php:202
14    1.3482    22046000    TYPO3\CMS\Extensionmanager\Utility\InstallUtility->loadExtension( )    ../InstallUtility.php:120
15    1.3482    22046000    TYPO3\CMS\Core\Package\PackageManager->activatePackage( )    ../InstallUtility.php:170
16    1.3483    22046000    TYPO3\Flow\Package\PackageManager->activatePackage( )    ../PackageManager.php:535
17    1.3483    22046176    TYPO3\Flow\Package\PackageManager->sortAndSavePackageStates( )   
../PackageManager.php:542
18    1.3483    22046176    TYPO3\CMS\Core\Package\PackageManager->sortAvailablePackagesByDependencies( )   
../PackageManager.php:914
19    1.3483    22047040    TYPO3\CMS\Core\Package\PackageManager->getAvailablePackageLoadingOrder( )   
../PackageManager.php:776
20    1.3483    22047040    TYPO3\CMS\Core\Package\PackageManager->buildDependencyGraph( )   
../PackageManager.php:719
21    1.3483    22047040    TYPO3\CMS\Core\Package\PackageManager->resolvePackageDependencies( )   
../PackageManager.php:684
22    1.3517    22091544    TYPO3\Flow\Package\PackageManager->getDependencyArrayForPackage( )   
../PackageManager.php:800
23    1.3517    22092568    TYPO3\Flow\Package\Package->getPackageMetaData( )    ../PackageManager.php:979
24    1.3519    22094600    TYPO3\CMS\Core\Package\PackageManager->getPackageKeyFromComposerName( )   
../Package.php:155
25    1.3519    22094600    TYPO3\Flow\Package\PackageManager->getPackageKeyFromComposerName( )   
../PackageManager.php:451

The dependent extension is activated nevertheless.

A file ./typo3/sysext/core/Resources/PHP/TYPO3.Flow/Classes/TYPO3/Flow/Package/Exception/InvalidPackageStateException.php
exists and contains the class.

When re-loading the extension manager, I can see the dependent extension activated and can now activate the extension I tried at
first.

History
#1 - 2014-01-31 17:09 - Thomas Maroschik
- Status changed from New to Needs Feedback
- Assigned To set to Thomas Maroschik

Does that still happen on current master?

#2 - 2014-02-12 09:55 - Ernesto Baschny
- Parent task set to #47018

#3 - 2014-02-14 10:38 - Christian Weiske

I cannot reproduce the issue anymore with 6.2beta5 (current master after 6.2beta5). Please close it.

#4 - 2014-02-14 10:40 - Thomas Maroschik
- Status changed from Needs Feedback to Closed

2015-08-04 2/2


